package it.inaf.oats.ia2.tap.tsm.model;

/**
 *
 * @author pietro
 */
public class Column extends EditablesContainer implements IDbEntity {

    private Status status;

    private String tableName;
    private String name;

    private final EditableValue<String> utype;
    private final EditableValue<String> ucd;
    private final EditableValue<String> unit;
    private final EditableValue<String> description;
    private final EditableValue<Boolean> std;

    private String datatype;
    private int size;

    private boolean isPrimaryKey;
    private boolean isForeignKey;
    private boolean principal;
    private boolean indexed;

    public Column() {
        super(UTYPE, UCD, UNIT, DESCRIPTION, STD);
        status = Status.NOT_SELECTED;

        utype = new EditableValue<String>();
        ucd = new EditableValue<String>();
        unit = new EditableValue<String>();
        description = new EditableValue<String>();
        std = new EditableValue<Boolean>();
    }

    public EditableValue<String> getUtypeEditableValue() {
        return utype;
    }

    public EditableValue<String> getUcdEditableValue() {
        return ucd;
    }

    public EditableValue<String> getUnitEditableValue() {
        return unit;
    }

    public EditableValue<String> getDescriptionEditableValue() {
        return description;
    }

    public EditableValue<Boolean> getStdEditableValue() {
        return std;
    }
//    private void setValue(ColumnField key, Serializable value) {
//        if (properties.containsKey(key)) {
//            properties.get(key).setValue(value);
//        } else {
//            properties.put(key, new EditableValue(value));
//        }
//    }
//    private Object getValue(ColumnField key) {
//        EditableValue value = properties.get(key);
//        if (value != null) {
//            return value.getValue();
//        }
//        return null;
//    }
//    private boolean checked;

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String columnName) {
        this.name = columnName;
    }

    public String getUtype() {
        return utype.getValue();
    }

    public void setUtype(String utype) {
        this.utype.setValue(utype);
    }

    public String getUcd() {
        return ucd.getValue();
    }

    public void setUcd(String ucd) {
        this.ucd.setValue(ucd);
    }

    public String getUnit() {
        return unit.getValue();
    }

    public void setUnit(String unit) {
        this.unit.setValue(unit);
    }

    public String getDescription() {
        return description.getValue();
    }

    public void setDescription(String description) {
        this.description.setValue(description);
    }

    public String getDatatype() {
        return datatype;
    }

    public void setDatatype(String datatype) {
        this.datatype = datatype;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }

    public boolean getPrincipal() {
        return principal;
    }

    public void setPrincipal(boolean principal) {
        this.principal = principal;
    }

    public boolean getIndexed() {
        return indexed;
    }

    public void setIndexed(boolean indexed) {
        this.indexed = indexed;
    }

    public boolean getStd() {
        return this.std.getValue();
    }

    public void setStd(boolean std) {
        this.std.setValue(std);
    }

    @Override
    public Status getStatus() {
        return status;
    }

    @Override
    public void setStatus(Status status) {
        this.status = status;
    }

    public boolean isPrimaryKey() {
        return isPrimaryKey;
    }

    public void setIsPrimaryKey(boolean value) {
        isPrimaryKey = value;
    }

    public boolean isForeignKey() {
        return isForeignKey;
    }

    public void setIsForeignKey(boolean value) {
        isForeignKey = value;
    }

    @Override
    public String getOriginalValue(String key) {
        if (key.equals(UTYPE)) {
            return this.getUtype();
        }
        if (key.equals(UCD)) {
            return this.getUcd();
        }
        if (key.equals(UNIT)) {
            return this.getUnit();
        }
        if (key.equals(DESCRIPTION)) {
            return this.getDescription();
        }
        if (key.equals(STD)) {
            return this.getStd() + "";
        }
        return null;
    }
}
