package it.inaf.oats.ia2.tap.tsm.model;

import java.io.Serializable;

/**
 * Object that keeps track of changes in the value that it wraps.
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 * @param <T> Class of the value contained in the object.
 */
public class EditableValue<T extends Serializable> implements Serializable {

    private final T originalValue;
    private T newValue;
//    private final IModel model;

    public EditableValue(T value) {
        originalValue = value;
        newValue = value;
        
//        model = new Model<T>() {
//            @Override
//            public T getObject() {
//                return getValue();
//            }
//
//            @Override
//            public void setObject(T obj) {
//                setValue(obj);
//            }
//        };
    }
    
    public EditableValue() {
        this(null);
    }

    public void setValue(T value) {
        newValue = value;
    }

    public T getValue() {
        return newValue;
    }

    public boolean isChanged() {
        if (originalValue == null && newValue.equals("")) {
            return false;
        }
        return originalValue != null && !originalValue.equals(newValue);
    }

//    public IModel getModel() {
//        return model;
//    }
}
