package it.inaf.oats.ia2.tap.tsm.model;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
public abstract class EditablesContainer {

    protected static final String UTYPE = "utype";
    protected static final String UCD = "ucd";
    protected static final String UNIT = "unit";
    protected static final String DESCRIPTION = "description";
    protected static final String STD = "std";
    
    private final HashMap<String, String> edits = new HashMap<String, String>();

    private final List<String> supportedValues;

    public EditablesContainer(String... params) {
        supportedValues = Arrays.asList(params);
    }

    public void setValue(String key, String value) {
        edits.put(key, value);
    }

    public abstract String getOriginalValue(String key);

    public String getValue(String key) {
        String value = edits.get(key);
        if (value == null) {
            return getOriginalValue(key);
        }
        return value;
    }

    public boolean isChanged(String key) {
        String value = edits.get(key);
        return value != null && !value.equals(getOriginalValue(key));
    }

    public List<String> getSupportedValues() {
        return supportedValues;
    }

}
