package it.inaf.oats.ia2.tap.tsm.pagemodel;

import it.inaf.oats.ia2.tap.tsm.model.EditablesContainer;
import it.inaf.oats.ia2.tap.tsm.model.Credentials;
import it.inaf.oats.ia2.tap.tsm.model.IDbEntity;
import it.inaf.oats.ia2.tap.tsm.model.Schema;
import it.inaf.oats.ia2.tap.tsm.model.Table;
import it.inaf.oats.ia2.tap.tsm.model.TapSchema;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Sonia Zorba <zorba at oats.inaf.it>
 */
//@XmlRootElement
public class SchemaPage {

    private transient TapSchema tapSchema;

    private ArrayList<Tab> schemasTabs;
    private int currentSchemaTab;

    private ArrayList<Tab> tablesTabs;
    private int currentTableTab;

    public SchemaPage() {
        Credentials credentials = new Credentials("localhost", 3306, "root", "root");
        Connection connection = null;
        try {
            connection = credentials.getConnection();

            tapSchema = new TapSchema(connection, "vlkb_voinfo_schema");
            schemasTabs = new ArrayList<Tab>();
            tablesTabs = new ArrayList<Tab>();

            selectSchema(0);
        } catch (SQLException e) {

        } finally {
            try {
                if (connection != null) {
                    connection.close();
                }
            } catch (SQLException e) {

            }
        }

        this.loadFields();
    }

    public final void loadFields() {

//        schemasTabs.clear();
//        for (IDbEntity schema : tapSchema.getAllEntities()) {
//            schemasTabs.add(new Tab(schema));
//        }
//
//        tablesTabs.clear();
//        if (!schemasTabs.isEmpty()) {
//            ArrayList<IDbEntity> tables = getCurrentSchema().getAllEntities();
//            for (IDbEntity table : getCurrentSchema().getAllEntities()) {
//                schemasTabs.add(new Tab(table));
//            }
//        }
    }

    private void selectSchema(int index) {
        currentSchemaTab = index;
        tablesTabs.clear();
//        if (!schemasTabs.isEmpty()) {
//            Schema currentSchema = (Schema) schemasTabs.get(currentSchemaTab).getDbEntity();
//            for (IDbEntity table : currentSchema.getAllEntities()) {
//                tablesTabs.add(new Tab(table));
//            }
//        }
    }

    private void selectTable(int index) {
        currentTableTab = index;
//        if(!tablesTabs.isEmpty()) {
//            Table currentTable 
//        }
    }

    public ArrayList<Tab> getSchemasTabs() {
        return schemasTabs;
    }

    public int getCurrentSchemaIndex() {
        return currentSchemaTab;
    }

    public ArrayList<Tab> getTablesTabs() {
        return tablesTabs;
    }

    public int getCurrentTableIndex() {
        return currentTableTab;
    }

//    @Override
//    public void executeCommand(String id, String command, String param) {
//        if (id.equals("page")) {
//            if (command.equals("selectSchema")) {
//                selectSchema(Integer.parseInt(param));
//            } else if (command.equals("selectTable")) {
//                selectTable(Integer.parseInt(param));
//            }
//        } else {
//            super.executeCommand(id, command, param);
//        }
//    }
    public String getValue(String container, String key) {
        return getContainer(container).getValue(key);
    }

    public boolean setValue(String container, String key, String value) {
        EditablesContainer ec = getContainer(container);
        ec.setValue(key, value);
        return ec.isChanged(key);
    }

    public boolean isChanged(String container, String key) {
        return getContainer(container).isChanged(key);
    }

    public Schema getCurrentSchema() {
        return (Schema) tapSchema.getSchema(schemasTabs.get(currentSchemaTab).getTitle());
    }

    public Table getCurrentTable() {
        return (Table) getCurrentSchema().getTable(tablesTabs.get(currentTableTab).getTitle());
    }

    public EditablesContainer getContainer(String containerName) {
        if (containerName.equals("schema")) {
            return getCurrentSchema();
        }
        return null;
    }
}
